#guard AntiLeakLibrary

library AntiLeakLibrary {
    include "cj_types_priv.j"
    native int GetPlayerUnitTypeCount(player p, int unitid)
    //??????????AntiBJ base
    setdef GetPlayerStartLocationLoc(p) = AntiLeakLibrary_RemoveLocation(GetStartLocation##Loc(GetPlayerStartLocation(p)))
    setdef GetUnitsInRangeOfLocAll(r, l) = AntiLeakLibrary_DestroyGroup(AntiLeakLibrary_GetUnitsInRangeOfLocMatching(r, l, null))
    setdef GetUnitsInRectAll(r) = AntiLeakLibrary_DestroyGroup(AntiLeakLibrary_GetUnitsInRectMatching(r, null))
    setdef GetUnitsOfPlayerAll(p) = AntiLeakLibrary_DestroyGroup(AntiLeakLibrary_GetUnitsOfPlayerMatching(p, null))
    setdef <call AddSpecialEffectLocBJ>(l, s) = call AntiLeakLibrary_AddSpecialEffectLocBJ(l, s)
    setdef <call AddSpecialEffectTargetUnitBJ>(a, w, s) = call AntiLeakLibrary_AddSpecialEffectTargetUnitBJ(a, w, s)
    //???? ??????????CreateRegions, ? ????????? ???RemoveRect
    define {
        <InitCustomTriggers()> = { InitCustom##Triggers(); AntiLeakLibrary_Remove = true }
        GetPlayerStartLocationLoc(p) = GetStartLocationLoc(GetPlayerStartLocation(p))
        GetUnitsInRangeOfLocAll(r, l) = GetUnitsInRangeOfLocMatching(r, l, null)
        GetUnitsInRectAll(r) = GetUnitsInRectMatching(r, null)
        GetUnitsOfPlayerAll(p) = GetUnitsOfPlayerMatching(p, null)
        <call AddSpecialEffectLocBJ>(l, s) = bj_lastCreatedEffect = AddSpecialEffectLoc(s, l)
        <call AddSpecialEffectTargetUnitBJ>(a, w, s) = bj_lastCreatedEffect = AddSpecialEffectTarget(a, w, s)
        GetDestructableLoc(d) = AntiLeakLibrary_RemoveLocation(AntiLeakLibrary_GetWidgetLoc(d))
        GetItemLoc(i) = AntiLeakLibrary_RemoveLocation(AntiLeakLibrary_GetWidgetLoc(i))
        GetRandomLocInRect(r) = AntiLeakLibrary_RemoveLocation(GetRandom##LocInRect(r))
        GetRectCenter(r) = AntiLeakLibrary_RemoveLocation(GetRect##Center(r))
        MeleeGetLocWithinRect(l, r) = AntiLeakLibrary_RemoveLocation(AntiLeakLibrary_MeleeGetLocWithinRect(l, r))
        MeleeGetProjectedLoc(l, targ, dist, a) = AntiLeakLibrary_RemoveLocation(MeleeGet##ProjectedLoc(l, targ, dist, a))
        OffsetLocation(l, x, y) = AntiLeakLibrary_RemoveLocation(OffsetLoc##ation(l, x, y))
        PolarProjectionBJ(l, r, a) = AntiLeakLibrary_RemoveLocation(AntiLeakLibrary_PolarProjectionBJ(l, r, a))
        WaygateGetDestinationLocBJ(u) = AntiLeakLibrary_RemoveLocation(Waygate##GetDestinationLocBJ(u))
        GetRectFromCircleBJ(l, r) = AntiLeakLibrary_RemoveRect(AntiLeakLibrary_RectFromCenterSizeBJ_GetRectFromCircleBJ(l, r, .0, false))
        OffsetRectBJ(r, x, y) = AntiLeakLibrary_RemoveRect(OffsetRect##BJ(r, x, y))
        RectFromCenterSizeBJ(l, width, heigth) = AntiLeakLibrary_RemoveRect(AntiLeakLibrary_RectFromCenterSizeBJ_GetRectFromCircleBJ(l, width, heigth, true))
        CountLivingPlayerUnitsOfTypeId(id, p) = GetPlayerUnitTypeCount(p, id)
        GetUnitsInRangeOfLocMatching(r, l, b) = AntiLeakLibrary_DestroyGroup(AntiLeakLibrary_GetUnitsInRangeOfLocMatching(r, l, b))
        GetUnitsInRectMatching(r, b) = AntiLeakLibrary_DestroyGroup(AntiLeakLibrary_GetUnitsInRectMatching(r, b))
        GetUnitsInRectOfPlayer(r, p) = AntiLeakLibrary_DestroyGroup(AntiLeakLibrary_GetUnitsInRectOfPlayer(r, p))
        GetUnitsOfPlayerAndTypeId(p, id) = AntiLeakLibrary_DestroyGroup(AntiLeakLibrary_GetUnitsOfPlayerAndTypeId(p, id))
        GetUnitsOfPlayerMatching(p, b) = AntiLeakLibrary_DestroyGroup(AntiLeakLibrary_GetUnitsOfPlayerMatching(p, b))
        GetUnitsOfTypeIdAll(id) = AntiLeakLibrary_DestroyGroup(AntiLeakLibrary_GetUnitsOfTypeIdAll(id))
        GetUnitsSelectedAll(p) = AntiLeakLibrary_DestroyGroup(AntiLeakLibrary_GetUnitsSelectedAll(p))
        GetForceOfPlayer(p) = AntiLeakLibrary_DestroyForce(AntiLeakLibrary_GetForceOfPlayer(p))
        GetPlayersAllies(p) = AntiLeakLibrary_DestroyForce(AntiLeakLibrary_GetPlayersAllies(p))
        GetPlayersByMapControl(mc) = AntiLeakLibrary_DestroyForce(AntiLeakLibrary_GetPlayersByMapControl(mc))
        GetPlayersEnemies(p) = AntiLeakLibrary_DestroyForce(AntiLeakLibrary_GetPlayersEnemies(p))
        GetPlayersMatching(b) = AntiLeakLibrary_DestroyForce(AntiLeakLibrary_GetPlayersMatching(b))
        MultiboardSetItemStyleBJ(mb, col, row, showVal, showIcon) = AntiLeakLibrary_MultiboardSetItemStyleBJ(mb, col, row, showVal, showIcon)
        MultiboardSetItemValueBJ(mb, col, row, val) = AntiLeakLibrary_MultiboardSetItemValueBJ(mb, col, row, val)
        MultiboardSetItemColorBJ(mb, col, row, r, g, b, t) = AntiLeakLibrary_MultiboardSetItemValueColorBJ(mb, col, row, r, g, b, t)
        MultiboardSetItemWidthBJ(mb, col, row, width) = AntiLeakLibrary_MultiboardSetItemWidthBJ(mb, col, row, width)
        MultiboardSetItemIconBJ(mb, col, row, icon) = AntiLeakLibrary_MultiboardSetItemIconBJ(mb, col, row, icon)
        <call AntiLeakLibrary_AddSpecialEffectLocBJ>(l, s) = {
            if AntiLeakLibrary_Remove {
                bj_lastCreatedEffect = null
                DestroyEffect(AddSpecialEffectLoc(s, l))
            } else {
                bj_lastCreatedEffect = AddSpecialEffectLoc(s, l)
            }
        }
        <call AntiLeakLibrary_AddSpecialEffectTargetUnitBJ>(a, w, s) = {
            if AntiLeakLibrary_Remove {
                bj_lastCreatedEffect = null
                DestroyEffect(AddSpecialEffectTarget(s, w, a))
            } else {
                bj_lastCreatedEffect = AddSpecialEffectTarget(s, w, a)
            }
        }
    }

    enum (AntiLeakLibrary_Leak) {
        private LocationLeak
        private RectLeak
        private GroupLeak
        private ForceLeak
    }

    private constant timer Timer = CreateTimer()
    private int MaxVar = -1
    private int array LeakNum
    private location array LocationVar
    private rect array RectVar
    private group array GroupVar
    private force array ForceVar
    private group Group
    private force Force
    public bool Remove = false

    private void RemoveLeak() {
        do {
            if MaxVar:LeakNum < GroupLeak {
                if MaxVar:LeakNum < RectLeak {
                    RemoveLocation(MaxVar:LocationVar)
                } else {
                    RemoveRect(MaxVar:RectVar)
                }
            } elseif MaxVar:LeakNum < ForceLeak {
                DestroyGroup(MaxVar:GroupVar)
            } else {
                DestroyForce(MaxVar:ForceVar)
            }
        } whilenot --MaxVar < 0
    }

    public rect RemoveRect(rect leak) {
        if Remove {
            MaxVar++
            MaxVar:RectVar = leak
            MaxVar:LeakNum = RectLeak
            if MaxVar == 0 { TimerStart(Timer, .0, false, function RemoveLeak) }
        }
        return leak
    }
    public rect RectFromCenterSizeBJ_GetRectFromCircleBJ(location l, real width, real height, bool b) {
        real x = GetLocationX(l), y = GetLocationY(l)
        if b {
            width *= .5
            height *= .5
            return Re##ct(x - width, y - height, x + width, y + height)
        }
        return Re##ct(x - width, y - width, x + width, y + width)
    }

    public location RemoveLocation(location leak) {
        if Remove {
            MaxVar++
            MaxVar:LocationVar = leak
            MaxVar:LeakNum = LocationLeak
            if MaxVar == 0 { TimerStart(Timer, .0, false, function RemoveLeak) }
        }
        return leak
    }
    public location GetWidgetLoc(widget w) {
        return Loc##ation(GetWidgetX(w), GetWidgetY(w))
    }
    public location PolarProjection##BJ(location l, real r, real a) {
        a *= .0174533
        return Loc##ation(GetLocationX(l) + Cos(a) * r, GetLocationY(l) + Sin(a) * r)
    }
    public location MeleeGetLoc##WithinRect(location l, rect r) {
        real minX = GetRectMinX(r), maxX = GetRectMaxX(r), \
            minY = GetRectMinY(r), maxY = GetRectMaxY(r)
        real x = GetLocationX(l), y = GetLocationY(l)
        if x < minX {
            x = minX
        } elseif x > maxX {
            x = maxX
        }
        if y < minY {
            return Loc##ation(x, minY)
        } elseif y > maxY {
            return Loc##ation(x, maxY)
        }
        return Loc##ation(x, y)
    }

    public group DestroyGroup(group leak) {
        if Remove {
            MaxVar++
            MaxVar:GroupVar = leak
            MaxVar:LeakNum = GroupLeak
            if MaxVar == 0 { TimerStart(Timer, .0, false, function RemoveLeak) }
        }
        return leak
    }
    public group GetUnitsInRange##OfLocMatching(real r, location l, boolexpr b) {
        Group = CreateGroup()
        GroupEnumUnitsInRangeOfLoc(Group, l, r, b)
        return Group
    }
    public group GetUnitsInRect##Matching(rect r, boolexpr b) {
        Group = CreateGroup()
        GroupEnumUnitsInRect(Group, r, b)
        return Group
    }
    public group GetUnitsInRect##OfPlayer(rect r, player p) {
        Group = CreateGroup()
        bj_groupEnumOwningPlayer = p
        GroupEnumUnitsInRect(Group, r, filterGetUnitsInRectOfPlayer)
        return Group
    }
    public group GetUnitsOfPlayer##Matching(player p, boolexpr b) {
        Group = CreateGroup()
        GroupEnumUnitsOfPlayer(Group, p, b)
        return Group
    }
    public group GetUnitsOfPlayer##AndTypeId(player p, int id) {
        Group = CreateGroup()
        bj_groupEnumTypeId = id
        GroupEnumUnitsOfPlayer(Group, p, filterGetUnitsOfPlayerAndTypeId)
        return Group
    }
    public group GetUnitsOfTypeId##All(int id) {
        group g = CreateGroup()
        bj_groupAddGroupDest = CreateGroup()
        bj_groupEnumTypeId = id
        for (int i = 0) {
            GroupEnumUnitsOfPlayer(g, Player(i), filterGetUnitsOfTypeIdAll)
            ForGroup(g, function GroupAddGroupEnum)
            exitwhen i == 15
            i++
        }
        Destroy##Group(g)
        g = null
        return bj_groupAddGroupDest
    }
    public group GetUnits##SelectedAll(player p) {
        Group = CreateGroup()
        SyncSelections()
        GroupEnumUnitsSelected(Group, p, null)
        return Group
    }

    public force DestroyForce(force leak) {
        if Remove {
            MaxVar++
            MaxVar:ForceVar = leak
            MaxVar:LeakNum = ForceLeak
            if MaxVar == 0 { TimerStart(Timer, .0, false, function RemoveLeak) }
        }
        return leak
    }
    public force GetForce##OfPlayer(player p) {
        Force = CreateForce()
        ForceAddPlayer(Force, p)
        return Force
    }
    public force GetPlay##ersAllies(player p) {
        Force = CreateForce()
        ForceEnumAllies(Force, p, null)
        return Force
    }
    public force GetPlayersByMap##Control(mapcontrol mc) {
        player p = Player(0)
        Force = CreateForce()
        for (int i = 0) {
            if GetPlayerController(p) == mc {
                ForceAddPlayer(Force, p)
            }
            exitwhen i == 15
            p = Player(++i)
        }
        p = null
        return Force
    }
    public force GetPlay##ersEnemies(player p) {
        Force = CreateForce()
        ForceEnumEnemies(Force, p, null)
        return Force
    }
    public force GetPlay##ersMatching(boolexpr b) {
        Force = CreateForce()
        ForceEnumPlayers(Force, b)
        return Force
    }

    //! textmacro AntiLeakLibrary__RegisterMultiboardUpdater takes NAME, ARGS, PARAMS, PRE
        public void Multiboard##SetItem$NAME$BJ(multiboard mb, int col, int row, $ARGS$) {
            int rows = MultiboardGetRowCount(mb)
            int cols = MultiboardGetColumnCount(mb)
            multiboarditem mbi
            $PRE$
            if col == 0 {
                if row == 0 {
                    MultiboardSetItems$NAME$(mb, $PARAMS$)
                } else {
                    row--
                    for (int i = 0; i < cols; i++) {
                        mbi = MultiboardGetItem(mb, row, i)
                        MultiboardSetItem$NAME$(mbi, $PARAMS$)
                        MultiboardReleaseItem(mbi)
                    }
                }
            } elseif row == 0 {
                col--
                for (int i = 0; i < rows; i++) {
                    mbi = MultiboardGetItem(mb, i, col)
                    MultiboardSetItem$NAME$(mbi, $PARAMS$)
                    MultiboardReleaseItem(mbi)
                }
            } else {
                mbi = MultiboardGetItem(mb, row - 1, col - 1)
                MultiboardSetItem$NAME$(mbi, $PARAMS$)
                MultiboardReleaseItem(mbi)
            }
            mbi = null
        }
    //! endtextmacro
    //! runtextmacro AntiLeakLibrary__RegisterMultiboardUpdater("Style", "bool showVal, bool showIcon", "showVal, showIcon", "")
    //! runtextmacro AntiLeakLibrary__RegisterMultiboardUpdater("Value", "string val", "val", "")
    //! runtextmacro AntiLeakLibrary__RegisterMultiboardUpdater("ValueColor", "real red, real green, real blue, real trans", "r, g, b, t", "int r = R2I(red * 2.55), g = R2I(green * 2.55), b = R2I(blue * 2.55), t = 255 - R2I(trans * 2.55)")
    //! runtextmacro AntiLeakLibrary__RegisterMultiboardUpdater("Width", "real width", "width", "width *= .01")
    //! runtextmacro AntiLeakLibrary__RegisterMultiboardUpdater("Icon", "string icon", "icon", "")
}
